<?php

# more icon centric FileBrowser
# (can only be used alternative to mod_fb)
#
# evaluates FBIconByType, FileBrowser, FBSortOrder, FBShowDotfiles, ...
# mostly like mod_fb
#
# mario&#x40;erphesfurtde

class mod_fb2 {

	var $modtype = "core_directory_handler";
	var $modname = "icon view directory listing";

	function init() {
		define("FB2_ICONS_IN_A_ROW", 5);
	}

	function main() {

		global $http_uri, $docroot, $conf, $vhost, $rq_err, $out_contenttype, $real_uri, $out_add_headers, $accessdir, $mime;

		if ($http_uri[strlen($http_uri)-1]!="/") $http_uri.="/";

		$icons = array(
			"default" => access_query("fbicondefault", 0),
			"directory" => access_query("fbicondirectory", 0)
		);
		foreach (access_query("fbiconbytype") as $line) {
			$uu = explode(" ", trim($line));
			$icons[ltrim($uu[1])] = $idir . $uu[0];
		}

		if (access_query("filebrowser", 0) && @is_readable($docroot.$http_uri)) {
			
			$rq_err = 200;
			$out_contenttype = "text/html";

# + desc file
			list($sort_by, $sort_reverse) = explode(" ", strtolower(trim(access_query("fbsortorder", 0))));

			$showhiddenfiles = access_query("fbshowdotfiles", 0);

			$dh = opendir(realpath($docroot . $http_uri));
			while ($fn = readdir($dh)) {

				if (($fn[0] == ".") && ($fn != "..") && !$showhiddenfiles) { continue; }

				$entry = stat($docroot . $http_uri . $fn);
				$entry["size"] = $entry[7];
				$entry["date"] = $entry[9];
				$entry["name"] = $fn;
				$entry["is_dir"] = is_dir($docroot . $http_uri . $fn);

				if ($fn == "..") {
					if ($http_uri == "/") continue;
					$entry["fname"] = "Parent Directory";
				}
				else {
					$entry["fname"] = $fn;
				}

				$entry["pathinfo"] = $pi = pathinfo($fn);
				$entry["mime"] = $mime[strtolower($pi["extension"])]
				or $entry["mime"] = $conf["global"]["defaultcontenttype"][0];
				
				if ($entry["is_dir"]) {
					$entry["mime"] = "unix/directory";
					$entry["icon"] = $icons["directory"];
				}
				else {
					$entry["icon"] = $icons["default"];
					foreach ($icons as $mt=>$icon) if (strpos($entry["mime"], $mt)!==false) $entry["icon"] = $icon;
				}

				$files[$fn] = $entry;
				$sorted_files[$fn] = strtolower($entry[$sort_by]);
			}
			closedir($dh);

			if (trim($sort_reverse)) arsort($sorted_files);
			else asort($sorted_files);


			#-- generate output
			$resp = '<H2>Index of /' . $real_uri . "</H2>\n";
			$resp .= '<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="10" SUMMARY="file list">' . "\n";

			$n = 0;
			foreach ($sorted_files as $fn => $uu) {

				if ($n == 0) { $resp .= "<tr>\n"; }

				$entry = & $files[$fn];

				$id = "i_" . base_convert(crc32($fn),10,36);

				$fdesc= "last modified: " . date("d-M-Y H:i:s", $entry[9]) .
					"&#10; &nbsp; - &nbsp; &#10;" .
					"size: " . number_format($entry[7])." bytes" . "&#10;";

				$resp.= "<td>" .
					'<div id="' . $id . '" align="center" class="fb2icon">' .
					'<a href="' . htmlentities($fn) . '"' .
/* <!--
						' onMousedown="fb2down(\''.$id.'\')"' .
						' onMouseup="fb2up()"' .
						' onMousemove="fb2move()"' .
						' onClick="this.blur()"' .
--> */
						'>' .
					'<img src="' . $entry["icon"] . '"' .
						' border="0" valign="bottom" width="32" height="32"' .
						' alt="' . $entry["mime"] . '"'.
						' title="' . $fdesc . '">'.
					'<br clear="both">' .
					htmlentities($entry["fname"]) .
					'</a>' .
					'</div>' .
					"</td>\n";

				$n = ($n + 1) % FB2_ICONS_IN_A_ROW;
				if ($n == 0) {
					$resp .= "</tr>\n";
				}

			}

			if ($n) {
				while ($n++ < FB2_ICONS_IN_A_ROW) {
					$resp .= "<td>&nbsp;</td>\n";
				}
				$resp .= "</tr>\n";
			}
			$resp .= "</TABLE>\n";

/* <!--
			$resp .= '<script language="JavaScript1.5" type="text/javascript">

				<!--
				fb2_selected_icon = "";
				function fb2down(id) {
					fb2_selected_icon = id;
					document.getElementById(id).style.backgroundColor = "#6666ff";
				}
				function fb2up() {
					document.getElementById(fb2_selected_icon).style.backgroundColor = "#ffffff";
					document.getElementById(fb2_selected_icon).blur();
					fb2_selected_icon = "";
				}
				function fb2move() {
					div = document.getElementById(fb2_selected_icon);
					div.style.position = "absolute";
					div.style.left = window.event.clientX + "px";
					div.style.top = window.event.clientY + "px";
				}
				//-->' .
				"\n\n</script>\n";
--> */

			if ($resp) $GLOBALS["lf"] =& new static_response(nw_page("Index of /".$real_uri, $resp));
				
		} else $rq_err=404;

	}

}



if (!function_exists("nw_page")) {
function nw_page($title, $body, $head="") {

	if (!($tm=&$GLOBALS["modules"]["theme_".strtolower(access_query("messagetheme",0))][0]) || !($page=$tm->page($title,$body,$head))) {

		$page="<html><head><title>".$title."</title>".$head."</head><body bgcolor=\"#ffffff\">";
		$page.=$body;
		$page.="<hr style=\"height:1px\"><font size=\"1\">"._genpage_signature()."</font></body></html>";

	}
	return($page);
}
}


/* -------
function nw_error_page($rq_err, $add_errmsg="") {
	
	global $HTTP_HEADERS, $http_resource, $conf, $vhost;

	$err_title = $HTTP_HEADERS[$rq_err];
	$err_page = "<h1>".$err_title."</h1>";

	if ($http_resource) $err_page.="An error occured trying to access document or resource <b>".htmlentities($http_resource)."</b>.<br><br>";
	
	if ($add_errmsg) {

		$err_page.=$add_errmsg;
		unset($add_errmsg);
	
	}

	return(nw_page($err_title, $err_page));

}
--- */

?>